/*
	link2tray.c

	original code: SASANO Takayoshi
	--- public domain, no warranty.
*/

#include <btron/btron.h>
#include <btron/hmi.h>
#include <errcode.h>
#include <bstdio.h>
#include <bstdlib.h>
#include <tstring.h>
#include <tcode.h>

/* main()֐̈{ */
EXPORT	W	main(W ac, TC *av[])
{
	W	err, i, n, addnl;
	TRAYREC	*tray;
	TR_VOBJREC	*vobj;
	LOCAL	const UH	nl = TC_NL;
	LOCAL	const TEXTSEG	tseg = {
		.view.c.left = 0,
		.view.c.top = 0,
		.view.c.right = 0,
		.view.c.bottom = 0,
		.draw.c.left = 0,
		.draw.c.top = 0,
		.draw.c.right = 0,
		.draw.c.bottom = 0,
		.h_unit = 0,
		.v_unit = 0,
		.lang = 0x0021,		// {
		.bgpat = 0,		// 
	};
	LOCAL	const VOBJSEG	vseg = {
		.view.c.left = 0,
		.view.c.top = 0,
		.view.c.right = 0,
		.view.c.bottom = 0,
		.height = 0,
		.frcol = 0x10000000,
		.chcol = 0x10000000,
		.tbcol = 0x10e0e0e0,
		.bgcol = 0x10ffffff,
		.dlen = 0,
	};

	if (ac < 2) {
		printf("usage: %S [filename] ...\n", av[0]);
		err = ER_PAR;
		goto fin0;
	}

	/* R}h̍Ō̕Z̏ꍇ͉sR[hǉȂ */
	addnl = (av[0][tc_strlen(av[0]) - 1] != TK_Z);

	/* ̊m - ׂvZ͏ȗ */
	tray = calloc(ac * (addnl + 1), sizeof(TRAYREC));
	if (tray == NULL) {
		printf("calloc NULL\n");
		err = ER_NOMEM;
		goto fin0;
	}

	vobj = calloc(ac, sizeof(TR_VOBJREC));
	if (vobj == NULL) {
		printf("calloc NULL\n");
		err = ER_NOMEM;
		goto fin1;
	}

	/* g[̐擪͕͊JnZOgƂ */
	tray[0].id = TS_TEXT;
	tray[0].len = sizeof(tseg);
	tray[0].dt = (B *)&tseg;

	/* g[R[h̍\z */
	n = 1;
	for (i = 1; i < ac; i++) {
		err = get_lnk(av[i], (LINK *)&vobj[i].vlnk, F_NORM);
		if (err < ER_OK) {
			printf("%S: file not found\n", av[i]);
			continue;
		}
		vobj[i].vseg = vseg;

		tray[n].id = TR_VOBJ;
		tray[n].len = sizeof(TR_VOBJREC);
		tray[n].dt = (B *)&vobj[i];
		n++;

		/* sǉꍇ */
		if (addnl) {
			tray[n].id = TR_TEXT;
			tray[n].len = sizeof(nl);
			tray[n].dt = (B *)&nl;
			n++;
		}
	}

	/* g[֏o */
	err = tpsh_dat(tray, n, NULL);
	if (err < ER_OK) {
		printf("tpsh_rec %d\n", err);
		goto fin2;
	}

	err = ER_OK;
fin2:
	free(vobj);
fin1:
	free(tray);
fin0:
	return err;
}
